"""autogenerated by genmsg_py from RobotCartConfiguration.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg

class RobotCartConfiguration(roslib.message.Message):
  _md5sum = "b6763adc7a4163e81b79c0de27053f06"
  _type = "cart_pushing_msgs/RobotCartConfiguration"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Robot's pose in reference frame
geometry_msgs/Pose robot_pose

# Cart's pose in base frame
geometry_msgs/Pose cart_pose
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['robot_pose','cart_pose']
  _slot_types = ['geometry_msgs/Pose','geometry_msgs/Pose']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       robot_pose,cart_pose
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(RobotCartConfiguration, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.cart_pose is None:
        self.cart_pose = geometry_msgs.msg.Pose()
    else:
      self.robot_pose = geometry_msgs.msg.Pose()
      self.cart_pose = geometry_msgs.msg.Pose()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_14d.pack(_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w, _x.cart_pose.position.x, _x.cart_pose.position.y, _x.cart_pose.position.z, _x.cart_pose.orientation.x, _x.cart_pose.orientation.y, _x.cart_pose.orientation.z, _x.cart_pose.orientation.w))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.cart_pose is None:
        self.cart_pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 112
      (_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w, _x.cart_pose.position.x, _x.cart_pose.position.y, _x.cart_pose.position.z, _x.cart_pose.orientation.x, _x.cart_pose.orientation.y, _x.cart_pose.orientation.z, _x.cart_pose.orientation.w,) = _struct_14d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_14d.pack(_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w, _x.cart_pose.position.x, _x.cart_pose.position.y, _x.cart_pose.position.z, _x.cart_pose.orientation.x, _x.cart_pose.orientation.y, _x.cart_pose.orientation.z, _x.cart_pose.orientation.w))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.cart_pose is None:
        self.cart_pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 112
      (_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w, _x.cart_pose.position.x, _x.cart_pose.position.y, _x.cart_pose.position.z, _x.cart_pose.orientation.x, _x.cart_pose.orientation.y, _x.cart_pose.orientation.z, _x.cart_pose.orientation.w,) = _struct_14d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_14d = struct.Struct("<14d")
