//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the cart_state_estimator package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __cart_state_estimator__POLYGONPOINTCLOUDFILTERCONFIG_H__
#define __cart_state_estimator__POLYGONPOINTCLOUDFILTERCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace cart_state_estimator
{
  class PolygonPointCloudFilterConfigStatics;
  
  class PolygonPointCloudFilterConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(PolygonPointCloudFilterConfig &config, const PolygonPointCloudFilterConfig &max, const PolygonPointCloudFilterConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const PolygonPointCloudFilterConfig &config1, const PolygonPointCloudFilterConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, PolygonPointCloudFilterConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const PolygonPointCloudFilterConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, PolygonPointCloudFilterConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const PolygonPointCloudFilterConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T PolygonPointCloudFilterConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (PolygonPointCloudFilterConfig::* field);

      virtual void clamp(PolygonPointCloudFilterConfig &config, const PolygonPointCloudFilterConfig &max, const PolygonPointCloudFilterConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const PolygonPointCloudFilterConfig &config1, const PolygonPointCloudFilterConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, PolygonPointCloudFilterConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const PolygonPointCloudFilterConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, PolygonPointCloudFilterConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const PolygonPointCloudFilterConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 11 "../cfg/PolygonPointCloudFilter.cfg"
      std::string frame_id;
//#line 13 "../cfg/PolygonPointCloudFilter.cfg"
      bool passthrough;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("PolygonPointCloudFilterConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const PolygonPointCloudFilterConfig &__max__ = __getMax__();
      const PolygonPointCloudFilterConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const PolygonPointCloudFilterConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const PolygonPointCloudFilterConfig &__getDefault__();
    static const PolygonPointCloudFilterConfig &__getMax__();
    static const PolygonPointCloudFilterConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const PolygonPointCloudFilterConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void PolygonPointCloudFilterConfig::ParamDescription<std::string>::clamp(PolygonPointCloudFilterConfig &config, const PolygonPointCloudFilterConfig &max, const PolygonPointCloudFilterConfig &min) const
  {
    return;
  }

  class PolygonPointCloudFilterConfigStatics
  {
    friend class PolygonPointCloudFilterConfig;
    
    PolygonPointCloudFilterConfigStatics()
    {
//#line 11 "../cfg/PolygonPointCloudFilter.cfg"
      __min__.frame_id = "";
//#line 11 "../cfg/PolygonPointCloudFilter.cfg"
      __max__.frame_id = "";
//#line 11 "../cfg/PolygonPointCloudFilter.cfg"
      __default__.frame_id = "cart";
//#line 11 "../cfg/PolygonPointCloudFilter.cfg"
      __param_descriptions__.push_back(PolygonPointCloudFilterConfig::AbstractParamDescriptionConstPtr(new PolygonPointCloudFilterConfig::ParamDescription<std::string>("frame_id", "str", 3, "Frame name of polygon", "", &PolygonPointCloudFilterConfig::frame_id)));
//#line 13 "../cfg/PolygonPointCloudFilter.cfg"
      __min__.passthrough = 0;
//#line 13 "../cfg/PolygonPointCloudFilter.cfg"
      __max__.passthrough = 1;
//#line 13 "../cfg/PolygonPointCloudFilter.cfg"
      __default__.passthrough = 1;
//#line 13 "../cfg/PolygonPointCloudFilter.cfg"
      __param_descriptions__.push_back(PolygonPointCloudFilterConfig::AbstractParamDescriptionConstPtr(new PolygonPointCloudFilterConfig::ParamDescription<bool>("passthrough", "bool", 3, "Passthrough filter (do not modify points)", "", &PolygonPointCloudFilterConfig::passthrough)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<PolygonPointCloudFilterConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<PolygonPointCloudFilterConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    PolygonPointCloudFilterConfig __max__;
    PolygonPointCloudFilterConfig __min__;
    PolygonPointCloudFilterConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const PolygonPointCloudFilterConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static PolygonPointCloudFilterConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &PolygonPointCloudFilterConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const PolygonPointCloudFilterConfig &PolygonPointCloudFilterConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const PolygonPointCloudFilterConfig &PolygonPointCloudFilterConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const PolygonPointCloudFilterConfig &PolygonPointCloudFilterConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<PolygonPointCloudFilterConfig::AbstractParamDescriptionConstPtr> &PolygonPointCloudFilterConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const PolygonPointCloudFilterConfigStatics *PolygonPointCloudFilterConfig::__get_statics__()
  {
    const static PolygonPointCloudFilterConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = PolygonPointCloudFilterConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __POLYGONPOINTCLOUDFILTERRECONFIGURATOR_H__
